<?
/*
 * (C) Copyright 2003 Krzysztof Gibas <sdas (at) gibas org>
 *                      - current maintainer
 *               2001 Gonthar <gonthar (at) moon net pl>
 *                      - developed scr_ipfm-0.1
 *
 * scr_ipfm generates graphical statistics from ipfm logs. 
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This  program is  distributed in the  hope  that  it will be useful,
 * but  WITHOUT  ANY  WARRANTY;  without even  the  implied warranty of
 * MERCHANTABILITY  or  FITNESS  FOR  A  PARTICULAR  PURPOSE.  See  the
 * GNU General Public License for more details.
 *
 * You  should  have  received a copy of the GNU General Public License
 * along  with  this  program;  if  not,  write  to  the  Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307,
 * USA.
 *
 * $Id: monthinyear.php,v 1.16 2003/11/08 00:56:54 gibas Exp $
 */

$sum_in = 0;
$sum_out = 0;
$sum_total = 0;

$in = 0;
$out = 0;
$total = 0;

//default values of variables.
secure_sort();
secure_flag();

$ar_years = create_ar_years();
$ar_months = create_ar_months();
$ar_days = create_ar_days();

secure_year();

$filename = "$ipfm_log_dir" . "ipfm-global-" . $_GET['year'];

$header = "Statistics for month-in-year " . $_GET['year'];

html_make_header_en($auto_refresh, $header, $version);

echo "<table class=\"tabletop\" border=\"0\" cellspacing=\"1\" cellpadding=\"3\"><tbody><tr class=\"tabletop\"><td>";
html_make_links_year("monthinyear");

echo "</td></tr></tbody></table>";

html_make_links("monthinyear");


check_dir_exists($ipfm_log_dir);
check_file_exists("$filename" . "-" . end($ar_months) . "-" . end($ar_days) . ".log", "year");

//sets global variables: $*_style, $s and $*_flag
set_style_flag_s();


$_GET['flag'] = invert_flag($_GET['flag']);

echo "
<table class=\"tablebottom\" border=\"0\" cellspacing=\"1\" cellpadding=\"3\">
<tbody>
<tr class=\"tablemain\">
    <td colspan=\"5\" align=\"right\">$header</td>
</tr>

<tr class=\"tablemain\">
    <td align=\"left\" class=\"sort\">Lp.</td>
    
    <td class=\"$host_style\" align=\"left\">
        <a class=\"sort\" href=\"index.php?monthinyear=1&amp;sort=host&amp;year=" . $_GET['year'] . "&amp;flag=" . $host_flag . "\">Month</a> 
    </td>

    <td class=\"$in_style\" align=\"right\">
        <a class=\"sort\" href=\"index.php?monthinyear=1&amp;sort=in&amp;year=" . $_GET['year'] . "&amp;flag=" . $in_flag . "\">In</a> 
	<a href=\"index.php?monthinyeargraph=1&amp;sort=in&amp;year=" . $_GET['year'] . "&amp;flag=" . $in_flag . "\">
	<img src=\"images/graph.png\" border=\"0\"></a>
    </td>

    <td class=\"$out_style\" align=\"right\">
        <a class=\"sort\" href=\"index.php?monthinyear=1&amp;sort=out&amp;year=" . $_GET['year'] . "&amp;flag=" . $out_flag . "\">Out</a> 
	<a href=\"index.php?monthinyeargraph=1&amp;sort=out&amp;year=" . $_GET['year'] . "&amp;flag=" . $out_flag . "\"
	<img src=\"images/graph.png\" border=\"0\"></a>
    </td>

    <td class=\"$total_style\" align=\"right\">
        <a class=\"sort\" href=\"index.php?monthinyear=1&amp;sort=total&amp;year=" . $_GET['year'] . "&amp;flag=" . $total_flag . "\">Total</a> 
	<a href=\"index.php?monthinyeargraph=1&amp;sort=total&amp;year=" . $_GET['year'] . "&amp;flag=" . $total_flag . "\">
	<img src=\"images/graph.png\" border=\"0\"></a>
    </td>
</tr>";


$ar_results = array();
$ar_results_all = array();

$string = "";
for ($l = 0; $l < count($ar_months); $l++) {
    $ar_results[$l][1] = 0;
    $ar_results[$l][2] = 0;
    $ar_results[$l][3] = 0;
    
    $_GET['month'] = $ar_months[$l];
    
    $ar_months = create_ar_months();
    $ar_days = create_ar_days();

    for ($k = 0; $k < count($ar_days); $k++) {
        $filename = "$ipfm_log_dir" . "/" . "ipfm-global-$_GET[year]-$ar_months[$l]-$ar_days[$k]" . ".log";
        $datas = file($filename);

        for($i=0; $i < count($datas); $i++) {
    
            if(preg_match("/^# /", $datas[$i])) {

                if(strstr("$datas[$i]", " IPFM")) {
                    //interface, time, version ipfm...
                    $string = split(" ", $datas[$i]);
    
                    //dirty hack - for old versions ipfm.
                    if($string[6] == "every") {
                        $string[9] = $string[7];
                        $string[13] = $string[11];
                    }
                }
            }
            else {
                if(strlen($datas[$i]) != 0) {
                    $elements = preg_split("/\s+/", $datas[$i]);
    
                    $host = $elements[0];
                    $in = $elements[1];
                    $out = $elements[2];
                    $total = $elements[3];

		    $ar_results[$l][0] = "href=\"index.php?sort=total&monthly=1&flag=ASC&year=" . $_GET['year'] . "&month=" . $ar_months[$l] . "\">" . $_GET['year'] . "-".$ar_months[$l] . "</a>";
                    $ar_results[$l][1] += $in;
                    $ar_results[$l][2] += $out;
                    $ar_results[$l][3] += $total;
                }
        
                $sum_in += $in;
                $sum_out += $out;
                $sum_total += $total;
            }
        }
    }
}

for ($i = 0; $i < $l; $i++) {
    if (isset($ar_results[$i][0])) {
        $line = $ar_results[$i][0] . " " . $ar_results[$i][1] . " " . $ar_results[$i][2] . " " . $ar_results[$i][3];
        array_push($ar_results_all, $line);
    }
}                                                                                                                   


if($_GET['flag'] == "ASC") {
    $datas = sortbycol($ar_results_all, $s, SORT_ASC);
}
else {
    $datas = sortbycol($ar_results_all, $s, SORT_DESC);
}
                        

for($i=0; $i < count($datas); $i++) {
    if(strlen($datas[$i]) != 0) {
        $elements = preg_split("/\s+/", $datas[$i]);
        
        $host = $elements[0];
        $in = $elements[1];
        $out = $elements[2];
        $total = $elements[3];

        //background color
        $style = set_table_bg_style($elements[$s]);
        
	$tmp = $i + 1;
    
	$host = "<a class=\"link\" " . $host;
	    
        html_make_result_host($style, $tmp, $host, $in, $out, $total);
    }
}

html_make_sum($sum_in, $sum_out, $sum_total);

html_make_empty_table();

html_make_version_table($string[1], $string[3], $string[9], $string[13], $version);

?>
